<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_CommonPriceBreakdown ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_CommonPriceBreakdown extends AbstractStructArrayBase
{
    /**
     * The Tax
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_CommonPriceBreakdown[]
     */
    public $Tax;
    /**
     * Constructor method for ArrayOfJP_CommonPriceBreakdown
     * @uses ArrayOfJP_CommonPriceBreakdown::setTax()
     * @param \StructType\JP_CommonPriceBreakdown[] $tax
     */
    public function __construct(array $tax = array())
    {
        $this
            ->setTax($tax);
    }
    /**
     * Get Tax value
     * @return \StructType\JP_CommonPriceBreakdown[]|null
     */
    public function getTax()
    {
        return $this->Tax;
    }
    /**
     * This method is responsible for validating the values passed to the setTax method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTax method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTaxForArrayConstraintsFromSetTax(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_CommonPriceBreakdownTaxItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_CommonPriceBreakdownTaxItem instanceof \StructType\JP_CommonPriceBreakdown) {
                $invalidValues[] = is_object($arrayOfJP_CommonPriceBreakdownTaxItem) ? get_class($arrayOfJP_CommonPriceBreakdownTaxItem) : sprintf('%s(%s)', gettype($arrayOfJP_CommonPriceBreakdownTaxItem), var_export($arrayOfJP_CommonPriceBreakdownTaxItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Tax property can only contain items of type \StructType\JP_CommonPriceBreakdown, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Tax value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_CommonPriceBreakdown[] $tax
     * @return \ArrayType\ArrayOfJP_CommonPriceBreakdown
     */
    public function setTax(array $tax = array())
    {
        // validation for constraint: array
        if ('' !== ($taxArrayErrorMessage = self::validateTaxForArrayConstraintsFromSetTax($tax))) {
            throw new \InvalidArgumentException($taxArrayErrorMessage, __LINE__);
        }
        $this->Tax = $tax;
        return $this;
    }
    /**
     * Add item to Tax value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_CommonPriceBreakdown $item
     * @return \ArrayType\ArrayOfJP_CommonPriceBreakdown
     */
    public function addToTax(\StructType\JP_CommonPriceBreakdown $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_CommonPriceBreakdown) {
            throw new \InvalidArgumentException(sprintf('The Tax property can only contain items of type \StructType\JP_CommonPriceBreakdown, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Tax[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_CommonPriceBreakdown|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_CommonPriceBreakdown|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_CommonPriceBreakdown|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_CommonPriceBreakdown|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_CommonPriceBreakdown|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Tax
     */
    public function getAttributeName()
    {
        return 'Tax';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_CommonPriceBreakdown
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
